#ifndef _GAMEDEFS_H

#ifdef _MAIN_C
 #define DECLARE
#else
 #define DECLARE extern
#endif

//// INCLUDE 

#include <sys/nearptr.h>
#include "allegro.h"
#include "images.h"

//// TYPEDEFS 

/*
   for some reason I thought this was better. It's in all the source so if
   you change it here, change it in ALL of 'em
*/
typedef char            INT8;
typedef unsigned        UINT8;
typedef int             INT16;
typedef unsigned        UINT16;
typedef long            INT32;
typedef unsigned long   UINT32;
typedef float           FLT;
typedef double          DBL;
typedef int             BOOL;

//// DEFINE 

/* RC() does the math for me. */

#define NOT             (0)
#define TRU             (1)
#define RC(n)           (n*32)

#define tilSIZE    32
#define maxLEVS     2
#define maxCOLS   30
#define maxROWS   30

//// DEFINE TILE 

//// GLOBALS 

DECLARE DATAFILE *data;
DECLARE BITMAP *ACTIVE, *scrnshot;
DECLARE BITMAP *SPRTMP, *EXECBODY[128], *EXECSHDW[128];
PALETTE game_pal;
DECLARE FLT xDelta, yDelta, tileX, tileY;
DECLARE FLT tcos[360], tsin[360];
DECLARE INT16 MapX, MapY;
DECLARE INT16 ticks, FPS, lastFPS;
DECLARE volatile INT16 timer;
DECLARE INT8 FPS_BUF[80], GMSHT_BUF[80];;
DECLARE UINT16 DONE, VRETRACE;
DECLARE static UINT16 screenshotNUM;

//// STRUCTURES 

typedef struct
{
 FLT   veloc,
       x,
       y,
       shdx,
       shdy,
       angle;
} PLAYER;

DECLARE PLAYER playa;

typedef struct
{
 unsigned char img;
} tileMAP;

DECLARE tileMAP levelMAP[maxLEVS][maxCOLS][maxROWS];

#define _GAMEDEFS_H
#endif
