VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "VBAlpha"
   ClientHeight    =   4710
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   5970
   LinkTopic       =   "Form1"
   ScaleHeight     =   4710
   ScaleWidth      =   5970
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox PicSpr 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   2595
      Left            =   2880
      ScaleHeight     =   2535
      ScaleWidth      =   2400
      TabIndex        =   2
      Top             =   1680
      Visible         =   0   'False
      Width           =   2460
   End
   Begin VB.PictureBox Pictbox 
      AutoSize        =   -1  'True
      Height          =   4650
      Left            =   15
      ScaleHeight     =   306
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   393
      TabIndex        =   0
      Top             =   45
      Width           =   5955
   End
   Begin VB.PictureBox Pictbuf 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   4470
      Left            =   60
      ScaleHeight     =   294
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   310
      TabIndex        =   1
      Top             =   45
      Visible         =   0   'False
      Width           =   4710
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Type SAFEARRAYBOUND
    cElements As Long
    lLbound As Long
End Type

Private Type SAFEARRAY1D
    cDims As Integer
    fFeatures As Integer
    cbElements As Long
    cLocks As Long
    pvData As Long
    Bounds(0 To 0) As SAFEARRAYBOUND
End Type

Private Type SAFEARRAY2D
    cDims As Integer
    fFeatures As Integer
    cbElements As Long
    cLocks As Long
    pvData As Long
    Bounds(0 To 1) As SAFEARRAYBOUND
End Type

Private Declare Function VarPtrArray Lib "msvbvm50.dll" Alias "VarPtr" (Ptr() As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)
Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type


Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Const SRCCOPY = &HCC0020 '
Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Dim level%

'lookup table
Dim trans(255, 255, 8) As Byte
'palettes
Dim pal1(8) As Byte
Dim pal2(8) As Byte

    
Private Sub Form_Load()

pal1(1) = 85: pal1(2) = 170: pal1(3) = 225
pal2(1) = 36: pal2(2) = 73: pal2(3) = 109: pal2(4) = 146: pal2(5) = 182: pal2(6) = 219: pal2(7) = 255

'load the images into the pictureboxes
Pictbox.Picture = LoadPicture("c:\Background.gif")
Pictbuf.Picture = LoadPicture("c:\Background.gif")
PicSpr.Picture = LoadPicture("c:\Figure.gif")

'Variables hold the RGB values of the source, destination, and the combination
'of the two
Dim Red_source%, Blue_source%, Green_source%
Dim Red_dest%, Blue_dest%, Green_dest%
Dim Red_combo%, Blue_combo%, Green_combo%

'~~~~~~~~~~~~~~~~~~~~~~The Look-Up Table~~~~~~~~~~~~~~~~~~~~~~~~~

For a% = 0 To 255
    'Source palette
    Blue_source% = a% Mod 4
    Green_source% = (a% \ 4) Mod 8
    Red_source% = a% \ 32
    For b% = 0 To 255
        Blue_dest% = b% Mod 4
        Green_dest% = (b% \ 4) Mod 8
        Red_dest% = b% \ 32
        'along 7 alpha channels
        For c% = 1 To 7
            Red_combo% = ((pal2(Red_source%) * (8 - c%)) + (pal2(Red_dest%) * c%)) / 8
            Blue_combo% = ((pal1(Blue_source%) * (8 - c%)) + (pal1(Blue_dest%) * c%)) / 8
            Green_combo% = ((pal2(Green_source%) * (8 - c%)) + (pal2(Green_source%) * c%)) / 8
            'the closest color match is going to be in the look-up table
            trans(a%, b%, c%) = CByte((Blue_combo% \ 85) + (Green_combo% \ 36) * 4 + (Red_combo% \ 36) * 32)
        Next
    Next
Next
End Sub
Sub PaintSprite()

Dim pict() As Byte
Dim pict2() As Byte
Dim pict3() As Byte

Dim sa As SAFEARRAY2D, bmp As BITMAP
Dim sa2 As SAFEARRAY2D, bmp2 As BITMAP
Dim sa3 As SAFEARRAY2D, bmp3 As BITMAP

Dim r As Integer, c As Integer

' get bitmap info
GetObjectAPI Pictbox.Picture, Len(bmp), bmp 'dest
GetObjectAPI Pictbuf.Picture, Len(bmp2), bmp2 'source
GetObjectAPI PicSpr.Picture, Len(bmp3), bmp3 'sprite


'Here, we store the locations of each bitmaps
'pixels in an array.

With sa
    .cbElements = 1
    .cDims = 2
    .Bounds(0).lLbound = 0
    .Bounds(0).cElements = bmp.bmHeight
    .Bounds(1).lLbound = 0
    .Bounds(1).cElements = bmp.bmWidthBytes
    .pvData = bmp.bmBits
End With
CopyMemory ByVal VarPtrArray(pict), VarPtr(sa), 4
    
' have the local matrix point to bitmap pixels
With sa2
    .cbElements = 1
    .cDims = 2
    .Bounds(0).lLbound = 0
    .Bounds(0).cElements = bmp2.bmHeight
    .Bounds(1).lLbound = 0
    .Bounds(1).cElements = bmp2.bmWidthBytes
    .pvData = bmp2.bmBits
End With
CopyMemory ByVal VarPtrArray(pict2), VarPtr(sa2), 4

' have the local matrix point to bitmap pixels
With sa3
    .cbElements = 1
    .cDims = 2
    .Bounds(0).lLbound = 0
    .Bounds(0).cElements = bmp3.bmHeight
    .Bounds(1).lLbound = 0
    .Bounds(1).cElements = bmp3.bmWidthBytes
    .pvData = bmp3.bmBits
End With
CopyMemory ByVal VarPtrArray(pict3), VarPtr(sa3), 4

'Copy the source bitmap
For c = 0 To UBound(pict, 1)
    For r = 0 To UBound(pict, 2)
        pict(c, r) = pict2(c, r)
    Next
Next

Dim Alpha As Byte
X = 70: Y = -20
'~~~~~~~~~~~~~~~~~~~Drawing of the sprites~~~~~~~~~~~~~~~~~~~~~~~
For c = 0 To 107
    For r = 0 To 126
        'work out the proportion of source vs destination
        '0 = 100% source
        '8 = 100% destination
        Alpha = pict3(c + 108, r)
        
        If Alpha > 0 Then 'not transparent
            If Alpha > 7 Then 'totally opaque
                pict(c + X, r - Y) = pict3(c, r)
            Else 'alphablt
                pict(c + X, r - Y) = trans(pict2(c + X, r - Y), pict3(c, r), Alpha)
            End If
        End If
    Next
Next

'clear temporary arrays
CopyMemory ByVal VarPtrArray(pict), 0&, 4
CopyMemory ByVal VarPtrArray(pict2), 0&, 4
CopyMemory ByVal VarPtrArray(pict3), 0&, 4


End Sub

Private Sub Pictbox_Click()
PaintSprite
Pictbox.Refresh
End Sub
